<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>

<body>

  <div class="container">
    <h2 style="text-align: center;">Danh sách người dùng</h2>

    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <script>
    function showUserInfo(id) {
      console.log("User ID:", id);
    }

    $(document).ready(function () {
      const gDATA_COLUMN = [
        "id",
        "firstname",
        "lastname",
        "country",
        "subject",
        "customerType",
        "registerStatus",
        "action"
      ];
      const gUSER_ID = 0;
      const gFIRST_NAME = 1;
      const gLAST_NAME = 2;
      const gCOUNTRY = 3;
      const gSUBJECT = 4;
      const gCUSTOMER_TYPE = 5;
      const gREGISTER_STATUS = 6;
      const gACTION = 7;

      onPageLoading();

      function onPageLoading() {
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
          type: "GET",
          dataType: 'json',
          success: function (paramObject) {
            console.log(paramObject);

            var dataTable = $('#user-table').DataTable({
              data: paramObject,
              columns: [
                { data: gDATA_COLUMN[gUSER_ID], className: 'text-center', render: function (data) { return '<span style="color: blue;">' + data + '</span>'; } },
                { data: gDATA_COLUMN[gFIRST_NAME] },
                { data: gDATA_COLUMN[gLAST_NAME] },
                { data: gDATA_COLUMN[gCOUNTRY] },
                { data: gDATA_COLUMN[gSUBJECT] },
                { data: gDATA_COLUMN[gCUSTOMER_TYPE] },
                { data: gDATA_COLUMN[gREGISTER_STATUS] },
                {
                  data: null,
                  className: 'text-center',
                  render: function (data) {
                    return '<button class="btn btn-primary btn-sm" onclick="showUserInfo(' + data[gUSER_ID] + ')">Chi tiết</button>';
                  }
                }
              ]
            });
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          }
        });
      }
    });
  </script>
</body>

</html>
